/*******************************************************************************
*                         Goggles Music Manager                                *
********************************************************************************
*           Copyright (C) 2006-2008 by Sander Jansen. All Rights Reserved      *
*                               ---                                            *
* This program is free software: you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program.  If not, see http://www.gnu.org/licenses.           *
********************************************************************************/
#ifndef GMPREFERENCES_H
#define GMPREFERENCES_H

enum {
  STARTUP_MAINWINDOW = 0,
  STARTUP_REMOTE,
  STARTUP_LAST
  };

class GMPreferences {
public:
	FXStringList gui_sort_keywords;

	FXString import_default_user_title;
	FXString import_default_user_album;
	FXString import_default_user_artist;
	FXString import_default_user_genre;

	FXString export_format_template;

  FXint  gui_startup;
  FXint  gui_last_startup;

	FXbool gui_show_status_bar;
	FXbool gui_always_show_remote;
	FXbool gui_hide_player_when_close;
  FXbool gui_toolbar_bigicons;
  FXbool gui_toolbar_docktop;
  FXbool gui_toolbar_showlabels;
  FXbool gui_show_browser_icons;
  FXbool gui_show_playing_albumcover;
  FXbool gui_show_albumcovers;

  FXColor gui_row_color;
  FXColor gui_play_color;
  FXColor gui_playtext_color;
  FXColor gui_sourceselect_color;
  FXColor gui_sourceselecttext_color;

	FXbool play_repeat_all;
	FXbool play_repeat;
  FXbool play_close_stream;
  FXbool play_pause_close_device;
  FXbool play_gapless;
  FXbool play_shuffle;
	FXbool play_open_device_on_startup;

	FXbool import_use_filename_for_title;
	FXbool import_use_directory_as_album;
	FXbool import_use_directory_as_artist;
	FXbool import_track_from_filelist;
	FXbool import_replace_underscores;

	FXuint export_encoding;
	FXbool export_lowercase;
	FXbool export_lowercase_extension;
	FXbool export_underscore;


  FXbool mugshot_notification;
  FXbool dbus_notify_daemon;
public:
	/// Default Constructor
	GMPreferences();

  void resetColors();

	/// Set Key Words
	void setKeyWords(const FXString & keywords);

	void getKeyWords(FXString & keywords) const;

	/// Save to FXSettings
	void save(FXSettings & settings) const;

	/// Load from FXSettings
	void load(FXSettings & settings);

	};

#endif

