/*******************************************************************************
*                         Goggles Music Manager                                *
********************************************************************************
*           Copyright (C) 2006-2008 by Sander Jansen. All Rights Reserved      *
*                               ---                                            *
* This program is free software: you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program.  If not, see http://www.gnu.org/licenses.           *
********************************************************************************/
#ifndef GMTRACKITEM_H
#define GMTRACKITEM_H

class GMTrackItem;

class GMDBTrackItem : public GMTrackItem {
  FXDECLARE(GMDBTrackItem)
public:
  static FXint max_queue;
  static FXint max_trackno;
  static FXint max_digits(FXint no);
protected:
  ///FXString title; FXIconItem::label
  FXString artist;
  FXString album;
  FXString genre;
//  FXString timestring;
//  FXint    time;    /* stored in bigIcon */
//  FXint 	 no;      /* stored in miniIcon */
  FXint    queue;
	FXushort year;
public:
  static FXint browseSort(const FXIconItem*,const FXIconItem*);
  static FXint ascendingTitle(const FXIconItem*,const FXIconItem*);
  static FXint descendingTitle(const FXIconItem*,const FXIconItem*);
  static FXint ascendingTrack(const FXIconItem*,const FXIconItem*);
  static FXint descendingTrack(const FXIconItem*,const FXIconItem*);
  static FXint ascendingQueue(const FXIconItem*,const FXIconItem*);
  static FXint descendingQueue(const FXIconItem*,const FXIconItem*);
  static FXint ascendingTime(const FXIconItem*,const FXIconItem*);
  static FXint descendingTime(const FXIconItem*,const FXIconItem*);
  static FXint ascendingAlbum(const FXIconItem*,const FXIconItem*);
  static FXint descendingAlbum(const FXIconItem*,const FXIconItem*);
  static FXint ascendingArtist(const FXIconItem*,const FXIconItem*);
  static FXint descendingArtist(const FXIconItem*,const FXIconItem*);
  static FXint ascendingGenre(const FXIconItem*,const FXIconItem*);
  static FXint descendingGenre(const FXIconItem*,const FXIconItem*);
  static FXint ascendingYear(const FXIconItem*,const FXIconItem*);
  static FXint descendingYear(const FXIconItem*,const FXIconItem*);
protected:
  GMDBTrackItem(){}
protected:
  virtual const FXString * getColumnData(FXint i,FXString & t,FXuint &justify,FXint & max) const;
public:
  GMDBTrackItem(FXint id,const FXchar * title,const FXchar * artist,const FXchar * album,const FXchar * genre,FXint time,FXuint no,FXint queue,FXushort year);

  void setTrackQueue(FXint q) { queue=q; }

  FXint getTrackQueue() const { return queue; }

  /// Return Track Number
  FXint getTrackNumber() const { return (FXint)(FXival)miniIcon; }

  /// Return Track Title
  FXString getTrackTitle() const { return label; }

  virtual ~GMDBTrackItem();
  };









class GMStreamTrackItem : public GMTrackItem {
  FXDECLARE(GMStreamTrackItem)
public:
  static FXint max_trackno;
  static FXint max_digits(FXint no);
protected:
  ///FXString title; FXIconItem::label
  FXString artist;
  FXString genre;
//  FXString timestring;
//  FXint    bitrate;    /* stored in bigIcon */
//  FXint 	 no;      /* stored in miniIcon */
public:
  static FXint ascendingTitle(const FXIconItem*,const FXIconItem*);
  static FXint descendingTitle(const FXIconItem*,const FXIconItem*);
  static FXint ascendingTrack(const FXIconItem*,const FXIconItem*);
  static FXint descendingTrack(const FXIconItem*,const FXIconItem*);
  static FXint ascendingGenre(const FXIconItem*,const FXIconItem*);
  static FXint descendingGenre(const FXIconItem*,const FXIconItem*);
protected:
  GMStreamTrackItem(){}
protected:
  virtual const FXString * getColumnData(FXint i,FXString & t,FXuint &justify,FXint & max) const;
public:
  GMStreamTrackItem(FXint id,const FXchar * title,const FXchar * genre,FXint no,FXint bitrate);

  /// Return Track Number
  FXint getTrackNumber() const { return (FXint)(FXival)miniIcon; }

  /// Return Track Title
  FXString getTrackTitle() const { return label; }

  virtual ~GMStreamTrackItem();
  };









#endif
