/*******************************************************************************
*                         Goggles Music Manager                                *
********************************************************************************
*           Copyright (C) 2006-2008 by Sander Jansen. All Rights Reserved      *
*                               ---                                            *
* This program is free software: you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program.  If not, see http://www.gnu.org/licenses.           *
********************************************************************************/
#ifndef FXWIZARDDIALOG_H
#define FXWIZARDDIALOG_H

class FXWizardDialog : public FXDialogBox {
  FXDECLARE(FXWizardDialog)
private:
  //FXFont *          titlefont;
	FXString					directory;
	FXDataTarget      dt_directory;
private:
  void setup(FXIcon *icon);
private:
  FXWizardDialog(){}
  FXWizardDialog(const FXWizardDialog&);
  FXWizardDialog& operator=(const FXWizardDialog&);
public:
	long onCmdSelectDir(FXObject*,FXSelector,void*);
public:
	enum {
		ID_SELECT_DIR = FXDialogBox::ID_LAST
		};
public:
/// Construct free-floating About dialog
  FXWizardDialog(FXApp* a,FXIcon * icon=NULL);

  /// Construct dialog which will always float over the owner window
  FXWizardDialog(FXWindow* owner,FXIcon * icon=NULL);

	void setDirectory(const FXString &);

	FXString getDirectory() const;

  /// Destructor
  virtual ~FXWizardDialog();
  };

#endif
