/*******************************************************************************
*                         Goggles Music Manager                                *
********************************************************************************
*           Copyright (C) 2007-2008 by Sander Jansen. All Rights Reserved      *
*                               ---                                            *
* This program is free software: you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program.  If not, see http://www.gnu.org/licenses.           *
********************************************************************************/
#ifdef HAVE_DBUS
#include "common.h"
#include "fxdbus.h"
#include "GMNotifyDaemon.h"

#define NOTIFY_NAME "org.freedesktop.Notifications"
#define NOTIFY_PATH "/org/freedesktop/Notifications"
#define NOTIFY_INTERFACE "org.freedesktop.Notifications"

FXDEFMAP(GMNotifyDaemon) GMNotifyDaemonMap[]={
  FXMAPFUNC(SEL_COMMAND,GMNotifyDaemon::ID_NOTIFY_RESULT,GMNotifyDaemon::onCmdNotify)
  };

FXIMPLEMENT(GMNotifyDaemon,FXObject,GMNotifyDaemonMap,ARRAYNUMBER(GMNotifyDaemonMap));

GMNotifyDaemon::GMNotifyDaemon(){
  }

GMNotifyDaemon::GMNotifyDaemon(FXDBusConnection* c) : dbus(c), replace_id(0) {
  }

long GMNotifyDaemon::onCmdNotify(FXObject*,FXSelector,void*ptr){
  DBusMessage * msg = (DBusMessage*)ptr;
  if (msg) {
    DBusMessageIter iter;
    dbus_message_iter_init(msg,&iter);
    dbus_message_iter_get_basic(&iter,&replace_id);
    //fxmessage("replace id = %d\n",replace_id);
    }
  return 1;
  }


void GMNotifyDaemon::notify(const FXchar * application,
                                   const FXchar * icon,
                                   const FXchar * summary,
                                   const FXchar * body,
                                   FXint timeout) {

  DBusMessage * msg = dbus_message_new_method_call(NOTIFY_NAME,NOTIFY_PATH,NOTIFY_INTERFACE,"Notify");
  if (msg) {
    DBusMessageIter iter;
    DBusMessageIter array;
    dbus_message_iter_init_append(msg,&iter);
    dbus_message_iter_append_basic(&iter,DBUS_TYPE_STRING,&application);
    dbus_message_iter_append_basic(&iter,DBUS_TYPE_UINT32,&replace_id);
    dbus_message_iter_append_basic(&iter,DBUS_TYPE_STRING,&icon);
    dbus_message_iter_append_basic(&iter,DBUS_TYPE_STRING,&summary);
    dbus_message_iter_append_basic(&iter,DBUS_TYPE_STRING,&body);
    dbus_message_iter_open_container(&iter,DBUS_TYPE_ARRAY,DBUS_TYPE_STRING_AS_STRING,&array);
    dbus_message_iter_close_container(&iter,&array);
    dbus_message_iter_open_container(&iter,DBUS_TYPE_ARRAY,"{sv}",&array);
    dbus_message_iter_close_container(&iter,&array);
    dbus_message_iter_append_basic(&iter,DBUS_TYPE_INT32,&timeout);
    dbus->sendWithReply(msg,-1,this,ID_NOTIFY_RESULT);
    }

  }
#endif
